define(function(require) {
	var $ = require("jquery");
	var jpushInstance = require("./jpush");
	var utils = require("$UI/demo/plugin/utils");

	require("res!$UI/system/lib/jquery/jquery-1.11.1.js");
	require("$UI/system/lib/cordova/cordova");
	require("cordova!cordova-plugin-app-version");
	require("cordova!cordova-plugin-screen-orientation");
	require("cordova!com.justep.cordova.plugin.weixin.v3");
	require("cordova!com.justep.cordova.plugin.alipay");
	
	require("cordova!cordova-plugin-background-mode");
	require("cordova!jpush-phonegap-plugin");
	require("cordova!cordova-plugin-camera");
    require("cordova!at.modalog.cordova.plugin.cache");
	var Model = function() {
		this.callParent();
	};
	
	var jpushEventFormat = function(event){
		var data = JSON.stringify(event);
    	console.log('~~~data~~~'+data);
        var json=$.parseJSON(data);
        console.log(json);
        var content=json.extras["cn.jpush.android.ALERT"];//消息内容
        var url=json.extras["cn.jpush.android.EXTRA"].url;
        if(url != null && url != ''){
        	console.log('url 1110 = '+url);
        	if(url.startsWith("../")){
        		url = url.replace("../","");
        	}
        	console.log('url 2220 = '+url);
        	location.href=url;
        }
        console.log('url end0 = '+url);
	}

	Model.prototype.indexDataReceiverReceive = function(event) {
		var position = event.data;
		var indexPanelId = $(this.getElementByXid("indexPanel")).attr('id');
		var $indexFrame = $('#' + indexPanelId + ' iframe')
		var indexFrame = $indexFrame.get(0);
		$indexFrame.on('load',function(){
			indexFrame.contentWindow.postMessage(position, "*");
		});
		// window.location.href="./Index/index.html"
	};
	Model.prototype.getConfiguration = function(callback){                      
        document.addEventListener("deviceready", onDeviceReady, false);        
        function onDeviceReady() {   
            if(cordova.getAppVersion){	
				cordova.getAppVersion.getConfiguration(function (configuration) {
					onSuccess(configuration)
				});			
			}       
        }       
        function onSuccess(configuration) {
            callback(configuration)
        }
    };
    
    /**
	 * 当请求支付已经到weixin应用但是失败 错误编码 以 -13 + message(message如果为weixin异常一定为负数) -13
	 * 当前环境不支持微信支付 -12 微信获取accessToken失败 -11 微信生成预支付订单失败 -10 微信支付请求被拒绝
	 */
	Model.prototype.payOrderByWeixin = function(data,success,error) {
		if (!navigator.weixin) {
			justep.Util.hint("微信支付加载失败");
			error();
			return;
		}
		var weixin = navigator.weixin;
		weixin.generatePrepayId({
			"body" : data.body,
			"feeType" : data.feeType,
			"notifyUrl" : data.notifyUrl,
			"totalFee" : data.totalFee,
			"traceId" : data.traceID,
			"tradeNo" : data.traceNo,
			"limitPay" : data.limitPay
		}, function(prepayId) {
			weixin.sendPayReq(prepayId, function(message) {
				var responseCode = parseInt(message);
				if (responseCode === 0) {
		//			justep.Util.hint("微信支付成功！");
					success();
				} else if (!isNaN(responseCode)) {
		//			console.log(JSON.stringify(responseCode));
		//			justep.Util.hint("微信支付失败1！");
					error();
				} else {
		//			justep.Util.hint("微信支付失败2！");
					error();
				}
			}, function(message) {
		//		justep.Util.hint("微信支付失败3！");
				error();
			});
		}, function(message) {
		//	justep.Util.hint("微信支付失败4！");
			error();
		});
	};
	
	
	Model.prototype.payOrderByWeixin2 = function(prepayId,success,error) {
		if (!navigator.weixin) {
			justep.Util.hint("微信支付加载失败");
			error();
			return;
		}
		var weixin = navigator.weixin;
		weixin.sendPayReq(prepayId, function(message) {
			var responseCode = parseInt(message);
			if (responseCode === 0) {
	//			justep.Util.hint("微信支付成功！");
				success();
			} else if (!isNaN(responseCode)) {
	//			console.log(JSON.stringify(responseCode));
	//			justep.Util.hint("微信支付失败1！");
				error();
			} else {
	//			justep.Util.hint("微信支付失败2！");
				error();
			}
		}, function(message) {
	//		justep.Util.hint("微信支付失败3！");
			error();
		});
	};
	
	// 集成极光推送 -- 获取推送的消息
	Model.prototype.sendRegPushId = function(callback) {
		console.log("~~~获取PushId~~~");
		jpushInstance.getRegistrationID().done(function(id) {
			console.log('获取的客户端唯一标识：'+id);
			onSuccess(id)
		//	return id;
		});
		function onSuccess(id) {
            callback(id)
        }
	};
	
	/**
     * 模型加载后回调事件.
     */
	Model.prototype.modelLoad = function(event) {
		console.log('进入ModelLoad加载方法');
		/*document.addEventListener('deviceready', function() {
			cordova.plugins.backgroundMode.enable();
		}, false);*/
		
		// 集成极光推送 -- 跳转至指定URL
		document.addEventListener("deviceready", onDeviceReady, false);
        // 加载完成
        function onDeviceReady() {
        	console.log('~~~onDeviceReady~~~');
            window.JPush.init();
            
            window.plugins.jPushPlugin.openNotificationInAndroidCallback = function(data) {//点击消息窗口
            	console.log('~~~data~~~');
            	jpushEventFormat(data);
             //   location.href=url;
            }
            
            window.plugins.jPushPlugin.onReceiveMessageInAndroidCallback = function(data) {//点击自定义消息窗口
            	console.log('~~~data~~~');
            	jpushEventFormat(data);
	         //   location.href=url;
	        }
            
            window.plugins.jPushPlugin.onReceiveNotificationInAndroidCallback = function(data) {//点击通知窗口
            	console.log('~~~data~~~');
            	jpushEventFormat(data);
	         //   location.href=url;
	        }
        }
        
    };
    
    Model.prototype.modelModelConstructDone = function(event){
    	this.portraitClick();
	};
    
    // 微信分享至消息
    Model.prototype.weixinClick = function(data, success, error) {
		navigator.weixin.share({
			message : {
				title : data.title,
				description : data.description,
				mediaTagName : data.mediaTagName,
				thumb : data.thumb,
				media : {
					// type: weixin.Type.WEBPAGE, // webpage
					webpageUrl : data.url
				// webpage
				}
			},
			scene : navigator.weixin.Scene.SESSION
		}, success, error);
	};

	// 微信分享至朋友圈
	Model.prototype.momentsClick = function(data, success, error) {
		navigator.weixin.share({
			message : {
				title : data.title,
				description : data.description,
				mediaTagName : data.mediaTagName,
				thumb : data.thumb,
				media : {
					// type: weixin.Type.WEBPAGE, // webpage
					webpageUrl : data.url
				// webpage
				}
			},
			scene : navigator.weixin.Scene.TIMELINE
		}, success, error);
	};
	
	// 调用照相机
	Model.prototype.cameraCordova = function(callback1,callback2){
        function onSuccess(imageURI) {
           callback1()
           window.resolveLocalFileSystemURL(imageURI, function(entry) {
               entry.file(function(file) {
                   var reader = new FileReader();
                   reader.onloadend = function(e) {
                       callback2(e.target.result)
                   };
                   reader.readAsDataURL(file);
               }, function(e) {
               })
           }, function() {
           });
       }
       function onFail(message) {
       }
       document.addEventListener("deviceready", onDeviceReady, false);        
       function onDeviceReady() {
           navigator.camera.getPicture(onSuccess, onFail, {quality : 50,correctOrientation:1});
       }
   }
	
	// 调用照相机
	Model.prototype.CreamPic = function(event){
        var urls = 'http://app.jinbaoyuan168.com/appapi/My/dowenjian1_ajax';
        function onSuccess(imageURI) {
        	 $.ajax({
        	        type: 'post',
        	        url: urls,
        	        data: imageURI,
//        	        cache: false,
//        	        processData: false,
//        	        contentType: false,
        	        dataType : 'json',
        	        headers:{'isajax':'1'},
        	        success:function(data){
        	            console.log(data);
        	            if(data.errcode==100){
        	              //  $('.pic').html('<img onclick="showPhoto()" src="http://'+$domain+'/Uploads/'+data.data.thumb+'">'+'<form id="uploadForm" enctype="multipart/form-data"><input id="thumb" onchange="fileSelected()" type="file" name="thumb"/></form>');
        	            }
        	        },
        	        error:function(err){
        	            console.log(err);
        	        },
        	        xhrFields:{
        	            withCredentials: true
        	        }
        	    })
    }
        function onFail(message) {
                alert("取消拍照");
        }
        navigator.camera.getPicture(onSuccess, onFail, {
                quality : 50,
                destinationType : Camera.DestinationType.DATA_URL,
                sourceType : Camera.PictureSourceType.CAMERA,
                mediaType : Camera.MediaType.PICTURE,
                EncodingType : Camera.EncodingType.JPEG,
                saveToPhotoAlbum : false
        });
}; 

	// 调用相册
	Model.prototype.imageCordova = function(callback1,callback2){
        function onSuccess(imageURI) {
//           console.log(imageURI);
        	callback1();
           window.resolveLocalFileSystemURI(imageURI, function(entry) { 
               entry.file(function(file) {
                   var reader = new FileReader();
                   reader.onloadend = function(e) {
                	   alert('e.target.result=='+e.target.result);
                       callback2(e.target.result)
                   };
                   reader.readAsDataURL(file);
               }, function(e) {
               })
           }, function() {
           });
           
       }
       function onFail(message) {
    	   alert('onFail='+message);
       }
       document.addEventListener("deviceready", onDeviceReady, false);        
       function onDeviceReady() {
           navigator.camera.getPicture(onSuccess, onFail, {
        	   quality : 50,
        	   sourceType: navigator.camera.PictureSourceType.PHOTOLIBRARY
           });
       }
   }
	
	
	
	// 调用相册
	Model.prototype.SelImageCordova = function(event){
        function onSuccess(imageURI) {
//           console.log(imageURI);
        	window.resolveLocalFileSystemURL(imageURI, 
                    function(fileEntry) {
                            alert("fileEntry: " + JSON.stringify(fileEntry));
                            alert("fileEntry.toURL()=" + fileEntry.toURL());
                            this.uploadImage(fileEntry.toURL());
                    }, 
                    function(error) {
                            alert("失败：" + JSON.stringify(error));
                    });
           
       }
       function onFail(message) {
    	   alert('onFail='+message);
       }
       document.addEventListener("deviceready", onDeviceReady, false);        
       function onDeviceReady() {
           navigator.camera.getPicture(onSuccess, onFail, {
        	   destinationType:navigator.camera.DestinationType.NATIVE_URI,
        	   quality : 50,
        	   sourceType: navigator.camera.PictureSourceType.PHOTOLIBRARY
           });
       }
   }
	
	//实现图片上传                
    Model.prototype.uploadImage = function(imageData){
    	var urls = 'http://app.jinbaoyuan168.com/appapi/My/dowenjian1_ajax';

     	 //图片上传
     	  $.ajax({
     	        type: 'post',
     	        url: urls,
     	        data: imageData,
     	        cache: false,
     	        processData: false,
     	        contentType: false,
     	        dataType : 'json',
     	        headers:{'isajax':'1'},
     	        success:function(data){
     	            console.log(data);
     	            if(data.errcode==100){
     	              //  $('.pic').html('<img onclick="showPhoto()" src="http://'+$domain+'/Uploads/'+data.data.thumb+'">'+'<form id="uploadForm" enctype="multipart/form-data"><input id="thumb" onchange="fileSelected()" type="file" name="thumb"/></form>');
     	            }
     	        },
     	        error:function(err){
     	            console.log(err);
     	        },
     	        xhrFields:{
     	            withCredentials: true
     	        }
     	    })                
    };
	
	//竖屏模式
	Model.prototype.portraitClick = function(event){
	    cordova.plugins.screenorientation.setOrientation('portrait');
	};

	return Model;
});