define(function(require) {
	var $ = require('jquery');
	require("cordova!cordova-plugin-device");
	var JPushInstance = function() {
		if (window.plugins && JPush) {
			document.addEventListener("deviceready", this.onDeviceReady.bind(this), false);
			document.addEventListener("jpush.openNotification", this.onOpenNotification.bind(this), false);
			document.addEventListener("jpush.receiveNotification", this.onReceiveNotification.bind(this), false);
			document.addEventListener("jpush.receiveMessage", this.onReceiveMessage.bind(this), false);
		}
	};
	
	// 跳转到固定URL
	var jpushDataFormat = function(event){
		var data = JSON.stringify(event);
        var json=$.parseJSON(data);
        var content=json.extras["cn.jpush.android.ALERT"];//消息内容
        var url=json.extras["cn.jpush.android.EXTRA"].url;
        if(url != null && url != ''){
        	console.log('url 111 = '+url);
        	if(url.startsWith("..")){
        		url = url.replace("../","");
        	}
        	console.log('url 222 = '+url);
      //  	location.href=url;
        }
        console.log('url end = '+url);
	}
	
	//初始化获取注册id可能会失败，主动调用获取注册id
	JPushInstance.prototype.getRegistrationID = function(){
		 var dtd = $.Deferred();
		 if (this.registrationID){
			 dtd.resolve(this.registrationID);
		 }else{
			 if (window.plugins && JPush){
				 JPush.getRegistrationID(function(registrationID) {
					 self.registrationID = registrationID;
					 if (self.registrationID){
						 dtd.resolve(self.registrationID);	 
					 }else{
						 dtd.reject();
					 }
				 });
			 }else{
				 dtd.reject();
			 }
		 }
		 return dtd.promise();
	};
	
	//设备准备好的时候获取注册id
	JPushInstance.prototype.onDeviceReady = function() {
		var self = this;
		JPush.init();
		JPush.getRegistrationID(function(registrationID) {
			console.log('registrationID='+registrationID);
			self.registrationID = registrationID;
		});
		if (device.platform == "Android") {
			JPush.setDebugMode(false);
		} else {
			JPush.setDebugMode(false);
		}
	};

	//打开通知的处理
	JPushInstance.prototype.onOpenNotification = function(event) {
		var alertContent;
		if (device.platform == "Android") {
			
			alertContent = window.plugins.jPushPlugin.openNotification.alert;
		} else {
			alertContent = event.aps.alert;
		}
		console.log('打开alertContent='+alertContent);
//		justep.Util.hint(alertContent);
	};

	//接收通知的处理 -- 极光、发送通知
	JPushInstance.prototype.onReceiveNotification = function(event) {
		var alertContent;
        if(device.platform == "Android"){
        	
        	jpushDataFormat(event);
        	alertContent = window.plugins.jPushPlugin.receiveNotification.alert;
        }else{
        	alertContent = event.aps.alert;
        }
//      console.log('通知alertContent='+alertContent);
		justep.Util.hint(alertContent);
	};

	//接收信息的处理 -- 极光、自定义消息
	JPushInstance.prototype.onReceiveMessage = function() {
		var message;
        if(device.platform == "Android"){
       		 message = window.plugins.jPushPlugin.receiveMessage.message;
        }else{
              message   = event.content;
        }
        console.log('信息message='+message);
		justep.Util.hint(message);
	};

	return new JPushInstance();
});